/* VR.C by Anthony Whitford */
#include <dos.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define VERSION 1.0
#define _MAX_COMMAND 128

void main (int argc, char *argv[])
{
  struct find_t file_info;
  char path[_MAX_PATH], drive[_MAX_DRIVE], dir[_MAX_DIR];
  char file[_MAX_FNAME], ext[_MAX_EXT], switches[_MAX_COMMAND];
  char cmd[_MAX_COMMAND];
  int userInput, counter;

  printf("Verify %1.1f (c)1990 by Anthony Whitford\n", VERSION);
  if (argc < 3) { /* If wrong args, print usage and example. */
    puts("Use:    VR command filespec [switches]");
    puts("Sample: VR COPY *.COM A: /V");
    exit(1);  /* Incorrect use */
  }
  _splitpath(argv[2], drive, dir, 0, 0);  /* Get drive, directory. */
  if (_dos_findfirst(argv[2], 0, &file_info)) {
    puts("Error: Invalid path or no matching files.");
    exit(2);  /* File not found */
  }
  switches[0] = '\0';                     /* Reset string. */
  for (counter = 3; counter < argc; counter++) {
    strcat(switches, " ");                /* Get program options */
    strcat(switches, argv[counter]);
  }
  do {
    _splitpath(file_info.name, 0, 0, file, ext);
    _makepath(path, drive, dir, file, ext);
    sprintf(cmd, "%s %s%s", argv[1], path, switches);
    printf("%s? (Y/N) ", cmd);           /* Verify action. */
    do {
      userInput = toupper(getch());
    } while ((userInput != 'Y') && (userInput != 'N'));
    printf("%c\n", (char)userInput);      /* Echo input. */
    if (userInput == 'Y')
      if (system(cmd))                    /* Do action. */
        puts("Error: Can't execute command.");
  } while (!_dos_findnext (&file_info));
  exit(0);
}
